// Script layout generated by ScriptFromUI Plugin

var bvqx = BrainVoyagerQX; // use short symbol to access BrainVoyager QX API

var scriptObj = new Object;
scriptObj.scriptNameForUser = "SegmentationHelper1_2"; // NOT relevant for Plugin GUI script - specify name by which script will be shown to user (e.g. in menu)
scriptObj.dialogFileName    = "SegmentationHelper1_2.ui"; // specify name of file that will be used by BVQX to create your UI
scriptObj.dialogAccessName  = "PluginDialog"; // specify the name you want to use for accessing your UI

//Apparently variables for GUI elements don't need to be initialized
// extra variables
var CurrentState = 0;
var StoredStates = 0;

scriptObj.initDlg = function()
{
   dlg = this.PluginDialog; // less to write
   // find push buttons
   estimateButton = dlg.toolsGB.estimateButton;
   growButton = dlg.toolsGB.growButton;
   cleanButton = dlg.toolsGB.cleanButton;
   talBBButton = dlg.toolsGB.talBBButton;
   segBBButton = dlg.toolsGB.segBBButton;
   resetBBButton = dlg.toolsGB.resetBBButton;
   updateBBButton = dlg.toolsGB.updateBBButton;
   clearOutsideButton = dlg.toolsGB.clearOutsideButton;
   clearInsideButton = dlg.toolsGB.clearInsideButton;
   expandButton = dlg.toolsGB.expandButton;
   countVoxelsButton = dlg.countGB.countVoxelsButton;
   quitButton = dlg.quitButton;
   set1Button = dlg.set1Button;
   addButton = dlg.addButton;
   resetButton = dlg.resetButton;
   // find radio buttons
   state0 = dlg.historyGB.state0;
   state5 = dlg.historyGB.state5;
   state1 = dlg.historyGB.state1;
   state6 = dlg.historyGB.state6;
   state2 = dlg.historyGB.state2;
   state7 = dlg.historyGB.state7;
   state3 = dlg.historyGB.state3;
   state8 = dlg.historyGB.state8;
   state4 = dlg.historyGB.state4;
   state9 = dlg.historyGB.state9;
   // find check boxes
   showBB = dlg.toolsGB.showBB;
   // find spin boxes
   fromIntensitySpinBox = dlg.toolsGB.fromIntensitySpinBox;
   toIntensitySpinBox = dlg.toolsGB.toIntensitySpinBox;
   cleanSpinBox = dlg.toolsGB.cleanSpinBox;
   xMin = dlg.toolsGB.xMin;
   yMin = dlg.toolsGB.yMin;
   zMin = dlg.toolsGB.zMin;
   xMax = dlg.toolsGB.xMax;
   yMax = dlg.toolsGB.yMax;
   zMax = dlg.toolsGB.zMax;
   
   //set some properties
   updateBBButton.visible = false;
   fromIntensitySpinBox.maximum = 224; // set range (here max value) of spin box
	 toIntensitySpinBox.maximum = 225;
	 fromIntensitySpinBox.value = 100; // change default value
	 toIntensitySpinBox.value = 200; // change default value
	 cleanSpinBox.minumum = 1;
   cleanSpinBox.maximum = 6;
	 cleanSpinBox.value = 4;

   //Bounding box values are set to 0-512 in the UI
   bvqx.SetPluginStringParameter("Command", "InitUI");
   bvqx.ExecutePlugin();
   xMax.maximum = xMax.value = bvqx.GetPluginIntParameter("xMax");
   yMax.maximum = yMax.value = bvqx.GetPluginIntParameter("yMax");
   zMax.maximum = zMax.value = bvqx.GetPluginIntParameter("zMax");


   //set radio button visibility
   this.setVisibility();

   // connec UI elements to script functions - you need to know the names of your elements (check your definition)
   estimateButton.clicked.connect(this, this.clicked_estimateButton);
   growButton.clicked.connect(this, this.clicked_growButton);
   expandButton.clicked.connect(this, this.clicked_expandButton);
   cleanButton.clicked.connect(this, this.clicked_cleanButton);
   
   talBBButton.clicked.connect(this, this.clicked_talBBButton);
   segBBButton.clicked.connect(this, this.clicked_segBBButton);
   resetBBButton.clicked.connect(this, this.clicked_resetBBButton);
   updateBBButton.clicked.connect(this, this.clicked_updateBB);
   showBB.clicked.connect(this, this.clicked_showBB);
   clearOutsideButton.clicked.connect(this, this.clicked_clearOutsideButton);
   clearInsideButton.clicked.connect(this, this.clicked_clearInsideButton);
   
   countVoxelsButton.clicked.connect(this, this.clicked_countVoxelsButton);
   
   quitButton.clicked.connect(this, this.clicked_quitButton);
   resetButton.clicked.connect(this, this.clicked_resetButton);
   set1Button.clicked.connect(this, this.clicked_set1Button);
   addButton.clicked.connect(this, this.clicked_addButton);
   
   state0.clicked.connect(this, this.restoreState);
   state1.clicked.connect(this, this.restoreState);
   state2.clicked.connect(this, this.restoreState);
   state3.clicked.connect(this, this.restoreState);
   state4.clicked.connect(this, this.restoreState);
   state5.clicked.connect(this, this.restoreState);
   state6.clicked.connect(this, this.restoreState);
   state7.clicked.connect(this, this.restoreState);
   state8.clicked.connect(this, this.restoreState);
   state9.clicked.connect(this, this.restoreState);
}


scriptObj.setVisibility = function()
{
   state1.enabled = StoredStates > 0 ? true : false;
   state2.enabled = StoredStates > 1 ? true : false;
   state3.enabled = StoredStates > 2 ? true : false;
   state4.enabled = StoredStates > 3 ? true : false;
   state5.enabled = StoredStates > 4 ? true : false;
   state6.enabled = StoredStates > 5 ? true : false;
   state7.enabled = StoredStates > 6 ? true : false;
   state8.enabled = StoredStates > 7 ? true : false;
   state9.enabled = StoredStates > 8 ? true : false;
}


scriptObj.getCurrentState = function()
{
   if (state0.checked) {CurrentState = 0;}
   if (state1.checked) {CurrentState = 1;}
   if (state2.checked) {CurrentState = 2;}
   if (state3.checked) {CurrentState = 3;}
   if (state4.checked) {CurrentState = 4;}
   if (state5.checked) {CurrentState = 5;}
   if (state6.checked) {CurrentState = 6;}
   if (state7.checked) {CurrentState = 7;}
   if (state8.checked) {CurrentState = 8;}
   if (state9.checked) {CurrentState = 9;}
}


scriptObj.setCurrentState = function()
{
   if (CurrentState == 0) {state0.checked = true;}
   if (CurrentState == 1) {state1.checked = true;}
   if (CurrentState == 2) {state2.checked = true;}
   if (CurrentState == 3) {state3.checked = true;}
   if (CurrentState == 4) {state4.checked = true;}
   if (CurrentState == 5) {state5.checked = true;}
   if (CurrentState == 6) {state6.checked = true;}
   if (CurrentState == 7) {state7.checked = true;}
   if (CurrentState == 8) {state8.checked = true;}
   if (CurrentState == 9) {state9.checked = true;}
}


scriptObj.restoreState = function()
{
   this.getCurrentState();
         
   bvqx.SetPluginStringParameter("Command", "RestoreState");
   bvqx.SetPluginIntParameter("CurrentState", CurrentState);
   
   bvqx.PrintToLog("Script>  Restoring State " + CurrentState);
   
   bvqx.ExecutePlugin();
}


scriptObj.clicked_estimateButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Estimate Limits button clicked");

   bvqx.SetPluginStringParameter("Command", "Estimate");

   bvqx.ExecutePlugin();
   
	 fromIntensitySpinBox.value = bvqx.GetPluginIntParameter("MinimumIntensity");
	 toIntensitySpinBox.value = bvqx.GetPluginIntParameter("MaximumIntensity");
}


scriptObj.clicked_growButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Grow Region button clicked");

   bvqx.SetPluginStringParameter("Command", "Grow");
   bvqx.SetPluginIntParameter("MinimumIntensity", fromIntensitySpinBox.value);
	 bvqx.SetPluginIntParameter("MaximumIntensity", toIntensitySpinBox.value);
	 bvqx.SetPluginIntParameter("xMin", xMin.value);
   bvqx.SetPluginIntParameter("yMin", yMin.value);
   bvqx.SetPluginIntParameter("zMin", zMin.value);
   bvqx.SetPluginIntParameter("xMax", xMax.value);
   bvqx.SetPluginIntParameter("yMax", yMax.value);
   bvqx.SetPluginIntParameter("zMax", zMax.value);

   bvqx.ExecutePlugin();
}


scriptObj.clicked_showBB = function()
{
   bvqx.PrintToLog("Script>  Dialog's Show Bounding Box clicked");

   bvqx.SetPluginIntParameter("showBB", showBB.checked);
   bvqx.SetPluginIntParameter("xMin", xMin.value);
   bvqx.SetPluginIntParameter("yMin", yMin.value);
   bvqx.SetPluginIntParameter("zMin", zMin.value);
   bvqx.SetPluginIntParameter("xMax", xMax.value);
   bvqx.SetPluginIntParameter("yMax", yMax.value);
   bvqx.SetPluginIntParameter("zMax", zMax.value);
   bvqx.SetPluginStringParameter("Command", "switchBB");

   bvqx.ExecutePlugin();
}

scriptObj.clicked_clearOutsideButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Clear Outside BB button clicked");
   
   bvqx.SetPluginIntParameter("xMin", xMin.value);
   bvqx.SetPluginIntParameter("yMin", yMin.value);
   bvqx.SetPluginIntParameter("zMin", zMin.value);
   bvqx.SetPluginIntParameter("xMax", xMax.value);
   bvqx.SetPluginIntParameter("yMax", yMax.value);
   bvqx.SetPluginIntParameter("zMax", zMax.value);
   bvqx.SetPluginStringParameter("Command", "clearOutside");

   bvqx.ExecutePlugin();
}

scriptObj.clicked_clearInsideButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Clear Inside BB button clicked");
   
   bvqx.SetPluginIntParameter("xMin", xMin.value);
   bvqx.SetPluginIntParameter("yMin", yMin.value);
   bvqx.SetPluginIntParameter("zMin", zMin.value);
   bvqx.SetPluginIntParameter("xMax", xMax.value);
   bvqx.SetPluginIntParameter("yMax", yMax.value);
   bvqx.SetPluginIntParameter("zMax", zMax.value);
   bvqx.SetPluginStringParameter("Command", "clearInside");

   bvqx.ExecutePlugin();
}

scriptObj.clicked_updateBB = function()
{
   //bvqx.PrintToLog("Script>  Update Bounding Box");
   if (showBB.checked == 1){
      bvqx.SetPluginIntParameter("showBB", showBB.checked);
      bvqx.SetPluginIntParameter("xMin", xMin.value);
      bvqx.SetPluginIntParameter("yMin", yMin.value);
      bvqx.SetPluginIntParameter("zMin", zMin.value);
      bvqx.SetPluginIntParameter("xMax", xMax.value);
      bvqx.SetPluginIntParameter("yMax", yMax.value);
      bvqx.SetPluginIntParameter("zMax", zMax.value);
      bvqx.SetPluginStringParameter("Command", "switchBB");
      
      bvqx.ExecutePlugin();
   }
}


scriptObj.clicked_talBBButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Talairach BB button clicked");
   
   bvqx.SetPluginStringParameter("Command", "talBB");
   bvqx.ExecutePlugin();
    //[59, 57, 52] - [197, 231, 172]
   xmin = bvqx.GetPluginIntParameter("xMin");
   ymin = bvqx.GetPluginIntParameter("yMin");
   zmin = bvqx.GetPluginIntParameter("zMin");
   xmax = bvqx.GetPluginIntParameter("xMax");
   ymax = bvqx.GetPluginIntParameter("yMax");
   zmax = bvqx.GetPluginIntParameter("zMax");
    
   bvqx.SetPluginIntParameter("updateBB", false);
   xMin.value = xmin;
   xMax.value = xmax;
   yMin.value = ymin;
   yMax.value = ymax;
   zMin.value = zmin;
   bvqx.SetPluginIntParameter("updateBB", true);
   zMax.value = zmax;
}


scriptObj.clicked_segBBButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Segmentation BB button clicked");

   bvqx.SetPluginStringParameter("Command", "segBB");

   bvqx.ExecutePlugin();
   
   xmin = bvqx.GetPluginIntParameter("xMin");
   xmax = bvqx.GetPluginIntParameter("xMax");
   ymin = bvqx.GetPluginIntParameter("yMin");
   ymax = bvqx.GetPluginIntParameter("yMax");
   zmin = bvqx.GetPluginIntParameter("zMin");
   zmax = bvqx.GetPluginIntParameter("zMax");
   
   bvqx.SetPluginIntParameter("updateBB", false);
   xMin.value = xmin;
   xMax.value = xmax;
   yMin.value = ymin;
   yMax.value = ymax;
   zMin.value = zmin;
   bvqx.SetPluginIntParameter("updateBB", true);
   zMax.value = zmax;
}


scriptObj.clicked_resetBBButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Reset BB button clicked");

   bvqx.SetPluginIntParameter("updateBB", false);
   xMin.value = 0;
   yMin.value = 0;
   zMin.value = 0;
   xMax.value = xMax.maximum;
   yMax.value = yMax.maximum;
   bvqx.SetPluginIntParameter("updateBB", true);
   zMax.value = zMax.maximum;
}


scriptObj.clicked_expandButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Expand button clicked");
   
   bvqx.SetPluginStringParameter("Command", "Expand");
   bvqx.SetPluginIntParameter("MinimumIntensity", fromIntensitySpinBox.value);
	 bvqx.SetPluginIntParameter("MaximumIntensity", toIntensitySpinBox.value);
	 bvqx.SetPluginIntParameter("xMin", xMin.value);
   bvqx.SetPluginIntParameter("yMin", yMin.value);
   bvqx.SetPluginIntParameter("zMin", zMin.value);
   bvqx.SetPluginIntParameter("xMax", xMax.value);
   bvqx.SetPluginIntParameter("yMax", yMax.value);
   bvqx.SetPluginIntParameter("zMax", zMax.value);

   bvqx.ExecutePlugin();
}


scriptObj.clicked_cleanButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Clean button clicked");

   bvqx.SetPluginStringParameter("Command", "Clean");
   bvqx.SetPluginIntParameter("CleanStrength", cleanSpinBox.value);
   bvqx.SetPluginIntParameter("showBB", showBB.checked);
  
   bvqx.ExecutePlugin();
}


scriptObj.clicked_countVoxelsButton = function()
{
    bvqx.PrintToLog("Script>  Dialog's Count Voxels button clicked");

    bvqx.SetPluginStringParameter("Command", "CountVoxels");
    bvqx.ExecutePlugin();
	
    var nrOfVoxels = bvqx.GetPluginIntParameter("NumberOfCountedVoxels"); // get result from plugin
    dlg.countGB.numberOfVoxelsEdit.text = nrOfVoxels;
}


scriptObj.clicked_quitButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Quit button clicked - closing dialog");
   dlg.close();
}


scriptObj.clicked_set1Button = function()
{
   bvqx.PrintToLog("Script>  Dialog's 'Set Current to State 1' button clicked");

   bvqx.SetPluginStringParameter("Command", "CurrentTo1");
   bvqx.SetPluginIntParameter("CurrentState", CurrentState);
   
   CurrentState = 1;
   StoredStates = 1;
   this.setCurrentState();
   this.setVisibility(); //using number of stored states 
   
   bvqx.ExecutePlugin();
}


scriptObj.clicked_resetButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's Reset button clicked");

   CurrentState = 0;
   StoredStates = 0;
   this.setCurrentState();
   this.setVisibility(); //using number of stored states 
}


scriptObj.clicked_addButton = function()
{
   bvqx.PrintToLog("Script>  Dialog's addButton button clicked");
   
   if (StoredStates>=9) {bvqx.MessageBox("No more states can be added");}
   else {
      StoredStates += 1;
      CurrentState = StoredStates;
      
      this.setVisibility(); //using number of stored states 
      this.setCurrentState();
      
      bvqx.SetPluginStringParameter("Command", "Add");
      bvqx.SetPluginIntParameter("CurrentState", CurrentState);
      bvqx.ExecutePlugin();
    }
}


returnScriptObj = function()
{
   return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj();
